﻿Version=7.0
NumberOfForms=0
NumberOfObjects=1
Object1=Bfile:BinaryFile
Sub designer
end sub
@EndOfDesignText@
Sub Globals
	'Declare the global variables here.
	
	' Standard B4A-Bridge commands
	Public PING, APK_COPY_START, APK_PACKET, APK_COPY_CLOSE, SEND_DEVICE_NAME As Byte
	PING = 1
	APK_COPY_START = 2
	APK_PACKET = 3
	APK_COPY_CLOSE = 4
	SEND_DEVICE_NAME = 5
	
	
	' Additional B4A_Bridge commands
	Public SEND_SDROOT, SEND_DIRSANDFILES, SEND_DIRS, SEND_FILES, END_DIRSANDFILES As Byte
	SEND_SDROOT = 100
	SEND_DIRSANDFILES  = 101 ' given directory
	SEND_DIRS  = 102
	SEND_FILES  = 103 
	END_DIRSANDFILES  = 104 ' given directory
	
	Public FILE_COPY_START, FILE_PACKET, FILE_COPY_CLOSE As Byte
	FILE_COPY_START = 110 ' given directory and filename
	FILE_PACKET = 111
	FILE_COPY_CLOSE = 112
	
	Public FILE_SEND, FILE_DELETE As Byte
	FILE_SEND = 120 ' given directory and filename
	FILE_DELETE = 121 ' given diectory and filename	
	
	Dim Buffer(0) As Byte
	Dim Data(0) As Byte
	Dim Temp(0) As Byte
		
End Sub

Sub SendCommand(command As Byte, payload As String)
	Data() = Main.Bstream1.StringToBytes(payload)
	SendCommandAndData(command)
End Sub

Sub SendCommandAndData(command As Byte) 
	ErrorLabel(SendDataErr)	
	
	Dim bufsize As Integer
	bufsize = ArrayLen(Data())
	Dim Buffer(5 + bufsize) As Byte

	' convoluted assignment to byte array elements avoid IDE bug
	Buffer(0) = (bufsize + 1) Mod 256 ' length
	Buffer(1) = Int((bufsize + 1) / 256)' length
	
	Buffer(4) = command ' command	
	ArrayCopy(Data(), 0, ArrayLen(Data()),Buffer(), 5)	
	Main.Bstream1.WriteBytes(Buffer())
	Return
SendDataErr:
	Main.btnB4A.Enabled = True
	Main.Timer1.Enabled = False
	Msgbox("Device connection lost!", "Network timeout")
End Sub

Public Sub SendPing
	SendCommand(PING, "")
	Return
End Sub

Public Sub GetSDRoot
	SendCommand(SEND_SDROOT, "")
	Return
End Sub

Public Sub GetDirsAndFiles(filenameanddir)
	Main.GettingFiles = True
	SendCommand(SEND_DIRSANDFILES, filenameanddir)
	Return
End Sub

Public Sub DeleteFile(filenameanddir)
	SendCommand(FILE_DELETE, filenameanddir)
	Return
End Sub

Public Sub SendFile(name, pcdir, b4adir)
	Dim numb As Integer
	FileOpen(con1, pcdir & name, cRandom)
	Bfile.New1(con1, True)
	SendCommand(FILE_COPY_START, b4adir & "," & name)
	Dim Temp(4096) As Byte
	Do
		numb = Bfile.ReadBytes(Temp(), ArrayLen(Temp()))
		If numb > 0 Then
			Dim Data(numb) As Byte
			ArrayCopy(Temp(), 0, numb, Data(), 0)
			SendCommandAndData(FILE_PACKET)
		End If
	Loop Until numb <> ArrayLen(Temp())	
	SendCommand(FILE_COPY_CLOSE, "")
	FileClose(con1)
End Sub

Public Sub InstallFile(name, pcdir)
	Dim numb As Integer
	FileOpen(con1, pcdir & name, cRandom)
	Bfile.New1(con1, True)
	SendCommand(APK_COPY_START, "")
	Dim Temp(4096) As Byte
	Do
		numb = Bfile.ReadBytes(Temp(), ArrayLen(Temp()))
		If numb > 0 Then
			Dim Data(numb) As Byte
			ArrayCopy(Temp(), 0, numb, Data(), 0)
			SendCommandAndData(APK_PACKET)
		End If
	Loop Until numb <> ArrayLen(Temp())	
	SendCommand(APK_COPY_CLOSE, "")
	FileClose(con1)
End Sub

Public Sub GetFile(filenameanddir)
	SendCommand(FILE_SEND, filenameanddir)
End Sub

